



                             ; Toujours mettre un espace
                             ; avant une instruction
                             ; mais pas avant un label
                             ; ni un .db "  " ou un .end
                             ; ou un .org ou un DATA = ...


                             ; pas d'espace avant ni dans
                             ; un nom de label (qui doit faire
                             ; moins de 16 caracteres) et pas
                             ; forcement de : apres

                             ; L'espace apres la virgule
                             ; apres ld ne semble pas obligatoire



#include "ti-85.h"


pos_1  =  TEXT_MEM+1  ; two bytes long
dir_1  =  TEXT_MEM+3  ; two bytes long
pos_2  =  TEXT_MEM+5  ; two bytes long
dir_2  =  TEXT_MEM+7  ; two bytes long
TEMPS  =  TEXT_MEM+9  ; two bytes long
DELAY  =  TEXT_MEM+11 ; two bytes long

.org 0
.db  "by    Antoine    RICHARD", 0


   res 1,(IY+0D)    ; don't alter text memory

   ROM_CALL(CLEARLCD)

   ld B,126
DessBord1:
   dec B
   ld C,55
   CALL_(NOIRCIR)   ; pour NOIRCIR : B= 0 a 127     C= 0 a 63
   ld C,2
   CALL_(NOIRCIR)
   ld A,2
   cp B
   JUMP_NZ(DessBord1)

   ld C,55
DessBord2:
   dec C
   ld B,125
   CALL_(NOIRCIR)
   ld B,2
   CALL_(NOIRCIR)
   ld A,2
   cp C
   JUMP_NZ(DessBord2)


   ld HL,$0403        ; pour afficher a colonne=x=4 ligne=y=3
   ld (CURSOR_ROW),HL ; il y a une colonne et une ligne n0
   ld BC,(PROGRAM_ADDR)
   ld HL,TextDelay
   add HL,BC
   ROM_CALL(D_ZT_STR)
   ld HL,300
Reglage_lenteur:
   ld (DELAY),HL       ; save HL
   ld HL,$0504         ; pour afficher a x=5 y=4
   ld (CURSOR_ROW),HL
   ld HL,(DELAY)       ; restore HL
   ROM_CALL(D_HL_DECI) ; display HL
   call GET_KEY
   ld HL,(DELAY)       ; restore HL
   cp 3
   CALL_Z(DelayPos)
   cp 4
   CALL_Z(DelayP100)
   cp 2
   CALL_Z(DelayNeg)
   cp 1
   CALL_Z(DelayM100)
   cp 9
   JUMP_Z(depart)
   cp 55
   JUMP_Z(depart)
   JUMP_(Reglage_lenteur)



DelayPos:
   inc HL
   ret
DelayNeg:
   dec HL
   ret
DelayP100:
   ld DE,100
   adc HL,DE
   ret
DelayM100:
   ld DE,100
   sbc HL,DE
   ret


depart:


   ld C,40
Efface_Lent_Text:
   dec C
   ld B,118     ; limite droite
ELT2:
   dec B

     ld A,4                  ; debut BLANCHIR
     out (5),A
     ROM_CALL(FIND_PIXEL)    ; a partir de B et C retourne A et HL
     ld DE,VIDEO_MEM
     add HL,DE
     xor 255
     and (HL)
     ld (HL),A               ; fin BLANCHIR

      ld A,13    ; limite gauche
   cp B
   JUMP_NZ(ELT2)
   ld A,25
   cp C
   JUMP_NZ(Efface_Lent_Text)








   ld B,22     ;   x       player 1     Directions =
   ld C,32     ;   y       player 1          1
   ld D,4      ; direction player 1         2 4
   ld E,1      ; number of player 1 life     3
   ld (pos_1),BC
   ld (dir_1),DE

   ld B,105    ;   x       player 2
   ld C,32     ;   y       player 2
   ld D,2      ; direction player 2
   ld E,1      ; number of player 2 life
   ld (pos_2),BC
   ld (dir_2),DE


   ld HL,0          ; temps global
   ld (TEMPS),HL    ; temps global


boucle1:            ;   debut de la  <<boucle principale>>
   ld HL,(TEMPS)
   inc HL
   ld (TEMPS),HL

  ld BC,(pos_1)   ; put in B and C the x and y of player 1
  CALL_(NOIRCIR)
  ld BC,(pos_2)   ; put in B and C the x and y of player 2
  CALL_(NOIRCIR)

   ld HL,(DELAY)      ; HL=temps restant avant fin de boucle_KEY

                      ;  boucle de ralentissement
Boucle_KEY:           ;  et de prise en compte des touches



  ld A,126   ; masks every keys exept arrows
  out (1),A  ; send A to keyboard port
  in A,(1)   ; read keyboard port

  ld DE,(dir_1)  ; put in D the direction of player 1
  bit 0,A              ; check if down is being pressed
  CALL_Z(touche_bas) 
  bit 1,A               ; check if left is being pressed
  CALL_Z(touche_gauche)
  bit 2,A               ; check if right is being pressed
  CALL_Z(touche_droite)
  bit 3,A              ; check if up is being pressed
  CALL_Z(touche_haut)
  ld (dir_1),DE    ; save D

  ld A,61    ; set bit 0,2,3,4,5
  out (1),A
  in A,(1)
  bit 6,A
  JUMP_Z(vers_ZShell)

  ld DE,(dir_2)   ; put in D the direction of player 2
  ld A,103       ; masks some keys
  out (1),A      ; send A to keyoard
  in A,(1)       ; read keyboard
  bit 1,A
  CALL_Z(touche_2)
  bit 2,A
  CALL_Z(touche_4)
  ld A,115       ; masks some keys
  out (1),A      ; send A to keyoard
  in A,(1)       ; read keyboard
  bit 2,A
  CALL_Z(touche_6)
  bit 3,A
  CALL_Z(touche_8)
  ld (dir_2),DE    ; save D


  dec HL
  ld DE,$FFFF
  call CP_HL_DE
  JUMP_NZ(Boucle_KEY)   ; repete Boucle_KEY  HL fois



   ld BC,(pos_1)
   ld DE,(dir_1)
      ld HL,$0200         ;  la ou sera afficher le temps
      ld (CURSOR_ROW),HL
  CALL_(change_BC)
   ld (pos_1),BC
   ld (dir_1),DE

   ld BC,(pos_2)
   ld DE,(dir_2)
      ld HL,$0D00         ;  la ou sera afficher le temps
      ld (CURSOR_ROW),HL
  CALL_(change_BC)
   ld (pos_2),BC
   ld (dir_2),DE

  JUMP_(boucle1)      ;  <<fin de la boucle principale>>




change_BC:
   LD A,E   ; bouge pas si mort
   or A     ; bouge pas si mort
   ret z    ; bouge pas si mort
  ld A,D
  cp 1
  CALL_Z(D1)
  cp 2
  CALL_Z(D2)
  cp 3
  CALL_Z(D3)
  cp 4
  CALL_Z(D4)
    push DE
    ld HL,(TEMPS)
    ROM_CALL(D_HL_DECI)   ; detruit D  ; affiche temps
    pop DE
  CALL_(SAVOIR)
  ret z           ; si pixel blanc retour sans baisser vie
  dec E
  ret



touche_haut:
  ld D,1
  ret
touche_gauche:
  ld D,2
  RET
touche_bas:
  ld D,3
  ret
touche_droite:
  ld D,4
  ret




touche_8:
  ld D,1
  ret
touche_4:
  ld D,2
  RET
touche_2:
  ld D,3
  ret
touche_6:
  ld D,4
  ret


vers_ZShell:
  ret


D1:
  inc C
  ret
D2:
  dec B
  ret
D3:
  dec C
  ret
D4:
  inc B
  ret



TextDelay:
.db "Lenteur :",0




;;;;;;#include "arbiblio.ant";;;  je l'ai mis directement

; Biblio de fonctions (prises ailleurs)


; noircir le pixel  x=B y=C
; Acc sera perdu

NOIRCIR:
   ld A,127
   cp B
   ret z 
   ld A,63
   cp C
   ret z 
   PUSH BC
   PUSH HL
   ld A,4
   out (5),A               ; set memory page to 4
   ROM_CALL(FIND_PIXEL)    ; a partir de B et C retourne A et HL
   ld BC,$FC00             ; $FC00 = video memory adress
   add HL,BC
   or (HL)
   ld (HL),A
   POP HL
   POP BC
   ret





; savoir si le pixel  x=B y=C
; Acc sera perdu

SAVOIR:
   PUSH BC
   PUSH HL
   ld A,127
   cp B
   ret z 
   ld A,63
   cp C
   ret z 
   ld A,4
   out (5),A
   ROM_CALL(FIND_PIXEL)
   ld BC,VIDEO_MEM
   add HL,BC
   and (HL)
   POP HL
   POP BC
   ret





.end   ; pas d'espace avant mais un ENTER apres
